﻿using System;
using RGiesecke.DllExport;
using System.Collections.Generic;

namespace Szamol
{
    public class Szamol
    {
        [DllExport]
        public static int KulonbozoNapok(string _napok)
        {
            string[] napok = _napok.Split(';');
            List<string> kulonbozoNapok = new List<string>();

            foreach (string nap in napok)
            {
                if (!String.IsNullOrEmpty(nap))
                {
                    if (!kulonbozoNapok.Contains(nap))
                        kulonbozoNapok.Add(nap);
                }
            }

            return kulonbozoNapok.Count;
        }

        [DllExport]
        public static int MunkaidoSzamitasI(string _munkaidok)
        {
            string[] munkaidok = _munkaidok.Split(';');
            DateTime dS, dE;
            int totalWorkTime = 0;

            foreach (string munkaido in munkaidok)
            {
                if (!String.IsNullOrEmpty(munkaido))
                {
                    try
                    {
                        dS = DateTime.ParseExact("20130124 " + munkaido.Substring(0, 5) + ":00", "yyyyMMdd HH:mm:ss", null);
                        dE = DateTime.ParseExact("20130124 " + munkaido.Substring(6, 5) + ":00", "yyyyMMdd HH:mm:ss", null);
                    }
                    catch (FormatException)
                    {
                        return -1;
                    }

                    TimeSpan tS = dE - dS;
                    totalWorkTime += (int)tS.TotalMinutes;
                }
            }

            return totalWorkTime;
        }

        [DllExport]
        public static string MunkaidoSzamitasS(string _munkaidok)
        {
            string[] munkaidok = _munkaidok.Split(';');
            DateTime dS, dE;
            int totalWorkTime = 0;

            foreach (string munkaido in munkaidok)
            {
                if (!String.IsNullOrEmpty(munkaido))
                {
                    try
                    {
                        dS = DateTime.ParseExact("20130124 " + munkaido.Substring(0, 5) + ":00", "yyyyMMdd HH:mm:ss", null);
                        dE = DateTime.ParseExact("20130124 " + munkaido.Substring(6, 5) + ":00", "yyyyMMdd HH:mm:ss", null);
                    }
                    catch (FormatException)
                    {
                        return "Hiba a számítás során! Az érvényes időformátum: HH:MM!";
                    }

                    TimeSpan tS = dE - dS;
                    totalWorkTime += (int)tS.TotalMinutes;
                }
            }

            if (totalWorkTime == 0)
                return "Nem volt mérhető időtöltés.";
            else if (totalWorkTime / 60 == 0)
                return String.Format("{0} perc", totalWorkTime % 60);
            else if (totalWorkTime % 60 == 0)
                return String.Format("{0} óra", totalWorkTime / 60);
            else
                return String.Format("{0} óra {1} perc", totalWorkTime / 60, totalWorkTime % 60);
        }

        [DllExport]
        public static int BerSzamitas(int munkaido, int oraDij, int kiszallasiDij, int kiszallasok)
        {
            return ((munkaido / 60) * oraDij) + (int)(((munkaido % 60d) / 60) * oraDij) + (kiszallasok * kiszallasiDij);
        }
    }
}
